#ifndef HARKIO_HARK_DATASET_HPP_
#define HARKIO_HARK_DATASET_HPP_

#include <string>
#include <harkio2/hark/Writable.hpp>

/** @file DataSet.hpp
 * @brief DataSetクラスの定義
 */

namespace harkio2
{
namespace hark
{

/** @brief データの集合を表す。
 *
 * このクラスはHARKファイルのための抽象的なデータ構造である。
 * RIFF形式におけるチャンクや、XML形式における部分木に対応する。
 */
class DataSet : public Writable
{
public:
    /// @brief 継承のための仮想デストラクタ
    virtual ~DataSet() {}

    /** @brief 型識別子（型ID）を返す。
     *
     * インスタンスの本当の型を表す識別子を返す。
     * 例えば"Fmt", "Spec"など。
     * @return 型識別子
     */
    virtual std::string GetId() const = 0;
};

}
}

#endif // HARKIO_HARK_DATASET_HPP_

