#define BOOST_TEST_MODULE testcase for Version class
#define BOOST_TEST_DYN_LINK
#include "common.hpp"

#include <boost/test/unit_test.hpp>

#include <harkio2/Version.hpp>

using namespace harkio2;

BOOST_AUTO_TEST_CASE(constructors_test)
{
    Version v1(1, 2);
    BOOST_CHECK_EQUAL(v1.GetMajor(), 1);
    BOOST_CHECK_EQUAL(v1.GetMinor(), 2);
}

BOOST_AUTO_TEST_CASE(operators_test)
{
    Version v0(1, 2);
    Version v1(1, 3);
    Version v2(2, 0);

    BOOST_CHECK(v0 != v1);
    BOOST_CHECK(v0 < v1);
    BOOST_CHECK(v0 <= v1);
    BOOST_CHECK(v1 > v0);
    BOOST_CHECK(v1 >= v0);

    BOOST_CHECK(v0 < v2);
}

